CHANGES
=======

6.0.0
-----

* Revert "Replace fnmatch with oslo.utils.fnmatch"
* vmware: Use oslo.vmware's get\_moref\_value()
* Fix Monasca-Setup Keystone detection
* Fix PY3 issue
* Fix typo in log message
* Fix Docker builds
* Add Python3 xena unit tests
* Remove incorrect plugins configuration for docker image
*  Fix small issue in dokcer plugin
* Fix zuul publish docker image job

5.0.0
-----

* Remove six
* Set 'libvirt\_type' and 'libvirt\_uri' options in the 'libvirt' plugin to be defined in conf.d/libvirt.yaml
* Replace assertItemsEqual with assertCountEqual
* bump py37 to py38 in tox.ini
* add py38 metedata
* Add Python3 wallaby unit tests
* bump py37 to py38 in tox.ini
* Adding python3-libvirt for Ubuntu-focal
* Replace assertItemsEqual with assertCountEqual
* Use importlib to take place of imp module

4.0.0
-----

* Update API version of monitored Cinder
* Avoid single quote in help text
* Convert byte-stream to 'utf-8'
* Use unittest.mock instead of mock
* Start README.rst with a better title
* Stop to use the \_\_future\_\_ module
* Remove dependency on local hostname
* Improve error handling in method that creates Monasca client
* Fix parsing of StatsD metrics with Py3
* Add CONTRIBUTING.rst
* Remove .testr.conf
* Fix libvirt ping\_checks documentation
* Fix flake8 errors
* Fix hacking min version to 3.0.1
* Add debug output for libvirt ping checks
* Add Python3 victoria unit tests

3.0.0.0rc1
----------

* Add remove configuration for matching arguments
* Do not copy /sbin/ip to /usr/bin/monasa-agent-ip
* Use unittest.mock instead of third party mock
* Cleanup py27 support
* Remove incorrect assignment of ping\_cmd to 'True'
* Update hacking for Python3
* Close db connection in mysql check
* Add Infiniband metrics plugin
* Add support for gathering Slab memory usage
* Ceph plugin updates for Luminous
* Enable running unit tests in py37 environment
* Fix misspell word
* [ussuri][goal] Drop python 2.7 support and testing
* Fix TOC section reference
* add X.509 certificate check plugin
* Update agent architecture diagram
* Switch to Ussuri jobs
* Add swift\_handoffs check plugin to monasca
* Add swift\_recon check plugin to monasca
* Add requirement for Prometheus plugin
* Update the constraints url
* Push Docker image to Docker Hub from Zuul
* Change Elasticsearch urls to fix failing metrics retrieval

2.11.0
------

* Create Docker image from Monasca repos
* Fix python 3 compatibility in statsd
* Update api-ref location
* Add missing space to log statement
* Enable unit tests for py36
* trivial fix: Correct some spelling errors
* Remove monasca-tempest-java-influxdb job
* Add Python 3 Train unit tests
* Update hacking version to 1.1.x
* Replace github.com with opendev.org
* Add information about Prometheus plugin to README
* Change repository links usage in Dockerfile and build image
* Blacklist bandit 1.6.0
* update git.openstack.org to opendev
* OpenDev Migration Patch
* Push Docker images to Docker Hub
* [docs] Add cross-tenant role using the openstack CLI
* Use proper naming for docker service image zuul job
* Update the cloudkitty detection plugin search pattern
* Build docker images in Zuul
* Do not add dimensions to init\_config

2.10.0
------

* monasca-setup  httpcheck args plugin: keystone\_config
* Ceph plugin detects client.admin keyring
* Support setting statsd metric aggregation interval
* Update OVS detection plugin for Keystone v3
* add python 3.7 unit test job
* properly convey Keystone v3 params
* Update log level classification info
* Improve error message when plugin detection fails
* docs: Be consistent with config options in the init\_config paragraph
* Add tempest tests jobs
* modify the description
* enable Keystone v3 support for http\_check detection plugin
* Add python classifier to setup.cfg
* Fix python3 compatibility
* Add tooling for building Docker images
* Change openstack-dev to openstack-discuss
* Add missing libvirt system dependency installation
* Update Libvirt.md with Installation steps
* Improve metric error handling
* Fix urllib references
* Remove setup.py check from pep8 job
* Add python36 support

2.9.0
-----

* add python 3.6 unit test job
* import zuul job settings from project-config
* Enable the system metrics in Docker environment
* Switch to using stestr
* Fix tests.detection.test\_mon

2.8.0
-----

* Convert README to reStructuredText
* Improvements to formatting
* Use six library to import python queue
* Configure Keystone with detection\_args for http\_check detection plugin
* fix tox python3 overrides
* Make forwarder and collector compatible with py35
* Trivial fix typo of description
* Enable the process plugin in Docker environment
* Python3: Make monasca-setup compatible with py35
* fix tox python3 overrides
* Removed dependency on supervisor
* Add Cloudkitty detection plugin (Cloudkitty - Rating Service)
* Fix sample for ZooKeeper plugin
* fix misspelling of 'monasca'
* fix misspelling of 'monasca'
* Trivial: Update pypi url to new url
* Correctly detects apache process when mod\_perl is installed
* Remove license section from README.md
* Fix log rotation in monasca agent
* Fix type error in monasca agent
* Allow Keystone config in init\_config for http check

2.7.0
-----

* Update old python string format
* Add Apache License
* Update pep8 checks
* uncap eventlet
* Add support for k8s StatefulSet
* Update links in README
* Fix libvirt plugin to handle FQDN of compute node
* Add prerequisite for enabling all untunable metrics
* Manual updated from global requirements
* Update supervisor version lower bound
* Remove PostgreSQL tempest jobs from Zuul
* [Trivialfix]Modify a grammatical error
* Manual update from global requirements
* Add LXC swap metric collector and fix lxc bug
* Correct detection status in congestion plugin
* Fix error logs in prometheus w/o prometheus annotations
* Use a newer hacking (1.0.x)
* Avoid overwriting sys.path "ip" command

2.6.0
-----

* Manual update from global requirements
* Zuul: Remove project name
* Add monasca agent plugin to monitor cassandra health
* Remove deprecated io\_loop argument
* Revert refresh\_token method
* Add new metrics for Cadvisor plugin
* Updated from global requirements
* Add owner type dimension so we can key off of it in alarming
* Update docstrings
* Update congestion agent plugin
* Fix ca\_file and insecure usage
* Rework getting limits and requests for containers
* Add max batch size for writing to API
* added license comments

2.5.0
-----

* Fix auto-detect crash on monasca-setup when using oslo.config
* Add container memory percentage metric when running in k8s
* Update k8s utils and prometheus plugin
* Added aggregate VM counts to livbirt check

2.4.0
-----

* Fix one error message in prometheus
* Remove -U from pip install
* Add network congestion detection to monasca
* Use monasca-common to validate metrics
* Avoid tox\_install.sh for constraints support
* Check interfaces KeyError for network data
* Fix Kibana plugin config duplication
* Fix hostname matching in kubernetes\_api plugin
* Add option for metric type annotation
* Update from global requirements
* Fix RabbitMQ whitelist documentation error
* readd nsfs to the list of ignored filesystems
* Add annotation for not adding kubernetes labels
* Add working set memory and job dimension to k8s/cadvisor  plugin
* Add .zuul.yaml file

2.3.0
-----

* Adding httpd-worker apache process on SLES
* libvirt check: use unqualified hostname
* Don't drop batch on one bad metric
* Ceph monitoring plugin: allow using sudo
* Introduce agent plugin for LXC
* Fix the example http\_check.yaml for Keystone
* added virtenv in gitignore
* added .stestr in gitignore
* Replace basestring with six.string\_types
* Add some new metrics and update some old ones
* change assert(Not)Equals to assert(Not)Equal
* Fix Prometheus metrics endpoint scanning
* Change template/example of Libvirt config file

2.2.0
-----

* Manual update from global requirements
* Fix slash handling in KubernetesConnector's get\_request
* Add a smaller vcenter plugin for status
* Fix libvirt plugin project/tenant name dimension
* Replace fnmatch with oslo.utils.fnmatch
* Update to global requirements
* Intergrate with osc-lib based client
* Integrate with keystoneauth
* Check OVS dependencies for python-novaclient
* Update documentation
* monasca\_setup: updated ovs detection plugin to use oslo\_config
* Various service detection fixes
* Ceph cluster plugin
* Check version using pbr module
* Refactor libvirt autodection and use oslo\_config
* [docs] Close literal/code block
* [doc] Fixed link and formatting in docs/MonascaMetrics.md
* [docs] Fix links in DeveloperDocs/agent\_internals.md
* Add alternate ping location
* Use kafka-python 0.9.5 from monasca-common
* Trivial fix typos
* Fix Zookeeper autodetection
* Define extra hacking rules to ensure code quality

2.1.0
-----

* Proper username detection for Postfix
* Enable cover for monasca\_setup
* Add dimension for influxdb-relay
* FIX monasca\_setup unit test
* Fix load plugin dimension
* Fix doc for kafka consumer plugin
* Add prometheus client plugin
* Change default kubernetes host
* Change dimension 'service' to 'component' on HAProxy plugin
* Fix version comparison on zookeeper plugin
* Fix libvirt plugin when using keystone v3
* Fix broken help commands for monasca-\*
* InfluxDB-Relay autodection
* Extend InfluxDB check
* [BUG] Support globally available kafka binaries
* Add Dimensions into White List
* Configurable logrotate in agent
* Fix Kubernetes Documentation
* monasca\_setup:to speedup detection, ask only for needed data for process
* Add Kubernetes API Plugin
* Ignore more non-device related filesystems
* Monasca agent on ESX hangs on collector autorestart
* Rollup network metrics and disk io metrics

2.0.0
-----

* Fix invalid log message
* Detect httpd on openSUSE/SLES
* Fix AttributeError: 'virDomain' object has no attribute 'id'
* Add white list for reporting metrics
* Add magnum service detection plugin
* OVS: Verify found configuration file
* Optimize the link address
* Correct instructions about Nagios Wrapper in Plugins.md
* Fix docker collector to report container name as a dimension
* Replace six.iteritems() with .items()
* python3 has disable LOG.warn
* Extend CI for monasca-agent
* Fix rabbitmq detection
* Do not hardcode configuration files location
* Partial support for DogStatsd extensions
* Find correct listener for WSGI based monasca-api
* Add network interface status metrics
* Vms with Chinese name failed to gather metrics
* Add 'agent\_service\_name' parameter to monasca-setup
* Fix log dir configuration for agent
* Use HostAddressOpt for opts that accept IP and hostnames
* Add Kubernetes plugin
* Introduce DynamicCheckHelper class
* Detect monasca-api with WSGI as Python implementation
* Libvirt detection fails if no --config-file flag given. Adds a check for default location of nova.conf
* Fix SLES platform detection
* Add cAdvisor host plugin
* Add Kubernetes Connector util class
* Fix corrupted table layout
* Add SLES to supported distributions
* Remove redundant metric mem.used\_mb and fix mem.used\_real\_mb
* [Fix gate]Update test requirement
* Add router count metric for ovs plugin
* Remove unused logging import
* use six.StringIO for compatibility with io.StringIO in python3
* Add ability to publish nova host aggregate info for libvirt metrics
* Implements A10 Load Balancer plugin configurations

1.7.0
-----

* Add support for psutil<2.0.0
* Password is now set to raw mode to support passwords that contain  a percent %
* Update psutil version to >= 3.0.1
* Add proxy configuration for tox.ini file
* This fixes the check class stop() interface so it allows subclass check to override the default behavior and adds the stop implementation in vcenter check so it logs out from vcenter session when the collector is stopped
* Fix nova client init for libvirt and ovs plugins
* Add router max bandwidth metrics to ovs plugin

1.6.0
-----

* Allow supervisor 3.3.x
* Add global\_delegeated\_tenant field to agent config
* Add Constraints support
* Distinguish between Java and Python for Mon
* Sync oslo/test-requirements with global-requirements

1.5.0
-----

* Check status on agent stop and wait if not stopped
* Fix to RabbitMQ detection plugin when using watch\_api=true
* Fix changing of dimensions in aggregator
* Add json\_plugin: simple way to post metrics to Monasca
* Stop exluding flake8 tests that are passing
* Sync to global-requirements
* add a one-line summary to the package metadata
* Show team and repo badges on README
* Domain being in shutoff state may have several reasons
* Fix version mismatch of oslo.utils
* Replaces tab to 4 whitespaces
* Properly read MySQL/MariaDB configuration file
* Fixing problems with tox

1.4.0
-----

* process.py detection plugin that accepts JSON string or YAML config
* Revert "Adjusting flake8 so that gate passes"
* Adjusting flake8 so that gate passes
* Improve docker plugin
* Fixed detection plugin for Heat (regex changed)
* Fixes WMI related checkers
* Make pep8 use py27
* Expand libvirt and ovs plugins to publish entity names
* Change match by when searching ntp process to ntpd
* Fix default dimensions in vcenter plugin
* Fixed Cinder detection plugin (wrong url)
* Add stevedore to requirements
* Change assertTrue(isinstance()) by optimal assert
* Add documentation for mapping metrics to config params
* Process stats from ElasticSearch matched by IP
* Add service\_type, endpoint\_type & region\_name querying Keystone Catalog
* Add target\_hostname to host alive metrics table
* Replace yaml.load() with yaml.safe\_load()
* Add a target\_hostname to Host Alive plugin
* Fixes process checker using older psutil versions
* Skip setting up handler for SIGUSR1 on Windows
* Properly get the conf.d folder
* Adds config-file arg option
* MySQL client password
* Add config option
* Improvements to rabbitmq check
* Better truncating for nagios check detail
* Add whitespaces to error messages
* Add prefix "$" for command examples
* Fix a typo in documentation
* TrivialFix: Using assertEqual instead of assertEquals
* Change cpu load averages to be normalized by core count

1.3.0
-----

* kafka\_consumer for kafka >= 0.9.0.0
* Include scale\_group metadata for customer metrics
* Fix a typo in util.py
* Use VM name as hostname for customer disk aggregates
* Add monasca-setup options max\_buffer\_size and backlog\_send\_rate
* Provide watch by user option to ServicePlugin
* Allow limiting the agent buffering on measurements instead of messages
* HttpCheck can't detect changes if only change search\_pattern
* Post process metric when the value is 0
* Fix api endpoint URL check
* Handle deleted flavors in libvirt check
* Add ntp connection status metric
* Fixes Monasca ceph detection plugin for multi-cluster
* Invalid kafka\_consumer documentation
* Add check to ignore network storage
* Use constraints everywhere
* Remove duplicate install\_command in tox.ini
* Remove unused tools/tox\_install.sh
* Make collection frequency of vnic metrics configurable
* Only output value meta of latest if it has a value
* Move other-requirements.txt to bindep.txt
* Typo needs to be fixed in jmxfetch.py
* Apache detection
* Add vertica new metrics
* Handle invalid input sent to monasca-forwarder
* Disk collection period has inconsistent collection timestamps
* Send host\_alive\_status after vm\_probation has expired
* For detection, treat libvirt vm\_probation as int
* Made collection times configurable
* Adding unit tests
* Fix cert\_check to use global collect\_period
* Duplicate code in rate metrics
* Removed Unnecessary cache updation for the router ports
* Need to send 0 values for Gauges
* self.name doesn't exist in Rate and Counter object
* Removing references to set and histgram metric types
* Changing conditional if we should send a rate metric or not
* Add SolidFire Monasca Check Plugin:
* Remove reference to removed metric types
* Kibana metrics
* Add back code that was accidentally overwritten
* Add Freezer API and Scheduler detection plugins
* Fix typo in cert\_check example
* Restricting flake8 version
* Parallelize the libvirt ping checks
* Remove measurement transformation from forwarder
* Fix some typo in the files
* cpu.time\_ns reports operator info in dimension
* Support for vCenter running on custom port
* Extended vm\_extended\_disks\_check\_enable attirbute
* Remove url from http\_status metric value\_meta
* Don't report operator data to customer
* Add region\_name into neutron-client for libvirt
* Add log.exception to get more info
* Eliminate use of hard-coded persister admin type/port
* Fix bug where missing router name causes metric post error
* Change tox.ini to not install requirements using global requirements
* Fix KeyError when posting ovs metrics that rolled over
* Kafka config naming conflict
* Add cpu.time\_ns for owning tenant
* Remove event related code in monasca-agent
* Revert watching file size for vertica log
* Use new name vertica.connection\_status
* Move cpu\_info assignment outside if statement
* Add missing parameter to \_inspect\_state
* Remove gearmand check plugin
* Fixed Plugin.md format error that caused broken links
* Report VM metrics for both tenant and operator
* Reduce error messages from http\_check
* Decrease duplicate calls to libvirt
* Fixed search pattern in Ironic detection plugin
* vertica.db.connection\_status not sending a metric for success case
* Fix total memory metric computation in libvirt
* find\_process\_server was not in \_\_init\_\_.py
* OVS detection plugin modification
* Added detection check to find process by service command. Modified RabbitMQ plugin to search for epmd process rather than rabbitmq-server wrapper script which has been removed as of version 3.6.2
* apache use\_server\_status\_metrics to filter
* Monitor vertica log file size in agent

1.2.0
-----

* Added qg-\*, sg-\* and vhu-\* ports as default in included\_interface\_re
* List system dependencies for running common tests
* Make plugin collection time warning value configurable
* Copy measurement before destructive update
* Modified rate metrics calculation
* Forgot to change one place to pool\_full\_max\_retries
* Use multiple threads to run the plugins
* vcenter detection plugin throws IndexError
* Added new flags to avoid collecting unnecessary metrics
* vm.cpu.time\_ms may be reporting cpu usage in nano seconds
* line:378 net.out\_packets\_dropped\_sec | device | Number of inbound network packets here 'inbound' should be 'outbound'
* Added qg-\*, sg-\* and vhu-\* ports as default in included\_interface\_re
* Remove restriction on python-monascaclient
* Certificate check detection plugin fails to log error
* Allow libvirt plugin to output disk metrics less often
* Change to log.exception for general catch exception
* Add parameters to configure libvirt checks
* Added port\_id in the Router and OVS metric dimensions
* Make wos\_used\_bytes equals 0 when reports ''
* MySQL check configuration
* Ignore E402 and W503 pep errors
* Lscpu doesn't always have the same output format
* Added metric support for DPDK ports
* VCenter config file
* Report network bytes transmitted and received counters
* Adding more metrics for disks
* Add detection plugin for enabling ovs plugin
* add --skip\_detection\_plugins arg. for skipping listed detection plugins
* Fix libvirt network naming with bits flag
* Add more compute cpu metrics
* Implemented vSwitch metrics for the router and dhcp ports
* port\_id dimension for port metrics causes plugin to fail
* Add cpu.utilization\_norm\_perc metric to libvirt
* Add vm.mem.resident\_mb metric
* Only attempt a cache update for missing instances once per agent wakeup
* Include region in neutron calls and handle missing port data
* Supervisord log message
* Rework Vertica plugin
* Add port\_id as a dimension for VM port related metrics
* Use both user and group for files agent creates
* Supervisord detection
* Fix mysql detection
* TLS mysql plugin support
* [monasca-agent] Change tox to use https instead of git
* Fix config check for mysql plugin
* Ensure collector exits promptly
* Lower log level for http skip ssl message
* Remove Oslo modules useless requirement
* Refactor process test
* Remove simplejson useless requirement
* Add plugin for gathering ovs virtual router statistics
* [monasca-agent] Constraint tox targets with upper-constraints
* Fix plugin documentation
* Refresh of Agent plugin documentation
* Rework agent to better handle multithreaded checks
* Allow Storm 1.0.x to be used as well as 0.9.x
* Add used memory metrics to memory plugin
* [Trivial] Remove unnecessary executable privilege
* Add customer metadata dimensions in libvirt plugin
* This code change is to fix a typo
* Remove import of check status in the collector daemon
* Increasing Monasca healthcheck timeout
* Add configurable units for network metrics
* Change tox file
* Migrate from MySQLDB to pymysql
* Fix rabbitmq plugin to handle no args or watch\_process arg
* ESX cluster monitoring dimension to have nova hostname
* observer\_hostname is actually used as oberver\_host
* Refactor agent
* Fix the debug message
* A couple small fixes to the postfix plugin
* Fix logic on skipping collections
* Kafka plugin not tracking consumer lag
* Chop value\_meta on nagios checks
* Set the name attribute on each instance
* Process check not respecting multiple search strigns
* Up the sub\_collection\_warn default value to 6
* Remove one check based on args in monasca-setup
* Trap errors in disk check
* Add a plugin to check the certificate expiration
* Add nsfs to the ignore file system list for the disk check
* Remove neutron-ns-metadata-proxy process check
* Set Kafka consumer auto\_commit to False
* Add RabbitMQ API check if RabbitMQ API exists
* Restrict libvirt VM ping check to IPv4
* Fix Agent Restarting Issue with Changing is to ==
* Change log level for permission denied on certain process checks
* Libvirt ping: treat empty remote\_ip\_prefix as open
* Remove sending the monasca emit time metric from vcenter check

1.1.24
------

* Ignore freezer backups
* Refactor Collector
* Reduce Error Messages from Directory Check
* Refactor forwarder
* Fix typo in docs
* vCenter detection reads hypervisor.conf
* Fixes ceph-radosgw detection logic
* Rabbitmq service is not being set for watching process by user
* Validate valueMeta for measurement
* Improved performance of process check
* remove extra process watch for vertica
* Improved performance of process check
* Ensure monasca agents report a useful user-agent
* Monasca-setup to configure for instance scale\_group metadata
* Add service dimension
* New Vertica plugin
* Fix Directory Check in Agent
* Adding more rabbit metrics
* Add collector\_restart\_interval in agent.yaml
* Use setcap instead of sudo in libvirt VM ping test
* Add process monitor for StrongSwan "charon" process
* Add process monitoring for Octavia
* Add HttpCheck in RabbitMQ
* Libvirt updates: ping check fix, CPU time metric
* Change process check setup and remove some process metrics
* Fix mysql detection plugin
* Detect Endpoint Changes in Http Check
* Documentation support for Elasticsearch
* Adds Ceph RADOS Gateway monitoring to ceph plugin
* Documentation: File\_size plugin
* Centos and RedHat added as supported distributions
* Add PowerDNS and BIND detection plugins
* Report Error from RabbitMQ Plugin
* infoblox-ipam-agent needs monitoring
* Change order of dimension override
* MonApi should not use DBI metrics with hibernate
* Show url in http\_check error message

1.1.23
------

* Revert "MonApi should not use DBI metrics with hibernate"
* Restart collector in agent every 24 hours
* Add Plugin to Monitor File Size
* FIX setup for libvirt
* Add HPE copyright
* MonApi should not use DBI metrics with hibernate

1.1.22
------

* Monasca VMWare vCenter plugin to monitor ESX clusters
* Changing service name Baremetal to baremetal

1.1.21
------

* Porting Supervisord check from DataDog
* Fix disk rollup metric names
* Update Agent Requirements.txt
* Add the ability to grab processes checks by user

1.1.20
------

* Remove vendor-specific paths on LBaaS agent executables
* neutron-l2gateway-agent needs monitoring
* Add process checks for monasca API and Persister
* Display collection time for each check
* FIX detection plugin for handling None object
* Drop MANIFEST.in - it's not needed with PBR
* py26 is no longer supported by Infra's CI
* Add ability to run ping tests against VMs
* FIX debug message to support multi-byte name
* Adding liberty versions of oslo to requirements.txt
* Change last of the URLs from stackforge to openstack
* Change the detailed process check
* Switch Agent thread count test to global threshold
* Improve output of host\_alive plugin's ping tests
* Delete python bytecode before every test run
* Add Designate process detection
* Add missing keystone process name
* Make Apache detection work on CentOS
* Include existing system PATH in nagios\_wrapper
* Fix the value meta for http\_status metrics
* Expire old VMs from libvirt metrics cache
* Replace host\_alive test with hypervisor VM states
* Fix use of collection frequency
* Speed up libvirt cache writes, fix corruption
* Add infomation for RabbitMQ Checks Description of the metrics for "RabbitMQ Checks" in the Monasca document is added
* Detection plugin for Barbican service
* Allow overriding values using args in ServicePlugin
* Allow config file 'instances' to be empty
* Document libvirt ping check limitations
* libvirt detection plugin adds bad instances
* Handle additional server options in ntp.conf

1.1.19
------

* Fix kafka collection
* Make process check error messages more accurate
* Add detection args to the apache plugin
* Add scale\_group dimension to libvirt plug-in
* Pass in all credentials to monclient for monclient token renewal
* Support the format of crash dump directory for RHEL7.1 and CentOS7.1
* Add Plugins descriptions for Monasca document
* Update .gitreview for new namespace
* Speed up kafka plugin
* Add service name to watch process calls in detection

1.1.18
------

* Adding additional process to Cue detection plugin
* Add setup option to skip all service/user config
* Libvirt nova: use internalURL endpoint, fix entry
* Do not collect disk stats on cdrom

1.1.17
------

* The metrics table for "Host Alive Checks" is missing
* Changed the way in which attrs were checked
* Add service dimension to monasca.emit\_time\_sec
* Removed limits on rabbitmq metric collection
* Rabbitmq reporting too many metrics
* Detect and correct invalid libvirt plugin caches
* Fix a description for "use\_keystone" in the "http\_checks.yaml"
* Add flavor caching to libvirt
* Add Plugins descriptions for Monasca document
* Speed up process check
* Change remaining megabytes to Mbytes

1.1.16
------

* Fixed pattern matching
* Fix statsd daemon
* Added service dimension to internal agent metrics
* Added service key to some HA proxy metrics
* Fix typo
* Accept Numerical Password
* Ignore negative libvirt samples and log for further investigation
* Change to a Dynamic Whitelist of Persister Metrics
* ADD description about MariaDB support and metrics semantics in "MySQL Checks"
* Unify unit expression for Monasca description
* Fix unit expression for Monasca description
* Fix Unit of Monasca document
* Limit libvirt Nova calls to the local compute node
* Modifed http\_check to init keystone clients and re-use
* Add options to limit certain metrics
* Treat detection of processes as a string not as a list of arguments
* Adds ceph service detection plugin
* Truncate Nagios detail output to <2048 characters
* Update component names for monasca
* Adding detection plugin for Trove
* Reduce nova calls when rebuilding libvirt instance cache
* Add Ironic Service detection plugin
* CINDER-65 cinder monitoring

1.1.15
------

* Fixing oslo.serialization requirement
* Allow apostrophes in dimension names and values
* Adding timeout parameter to client initialization
* Don't fail when /etc/monasca/api-config.yml is not found
* Adding stricter requirements
* Added process checks for Vertica and InfluxDB

1.1.14
------

* add support for (user-) domain\_id/name
* Remove watchdog from the agent
* FIX the log message for VMs in the probation period
* Fixed default process metrics
* Accept Unicode in the Aggregator
* Add aggregator checks for the collecter to match the api
* Updating unit tests
* Updating unit tests
* Add VM memory metrics to libvirt plugin
* Exclude the tap device from the default list for the Network checks
* Fix libvirt plugin bug for newly created VMs
* Differentiate heat-api from heat-api-\* services
* Fix for reading partition number from kafka
* Fixing keystone singleton problem
* Make the Config class be a singleton
* Allow the kafka consumer to use arguments that specify consumers
* FIX the judge condition for "device\_blacklist\_re" of Disk Checks
* Add process monitoring for LBaaS agents
* FIX apache checks
* Adding detection plugin for Cue
* Strip extra whitespace found in /etc/haproxy/haproxy.cfg

1.1.12
------

* Fix some circular imports
* Fix for multiple hostnames and the host\_alive plugin
* Normalize the observer hostname
* Fixing flake8 errors now that tox is working again
* Keep the full url when choosing a non-localhost port
* Handle the situation where detection plugin args is a dict

1.1.11
------

*  ovsvapp process name changed impacting monasca detection plugin
* Drop target\_host and just set it to the hostname for host\_alive plugin
* Add reasonable default timeouts for host\_alive
* Minor service plugin code cleanup
* Add information for Zookeeper checks
* Clean up check\_mk\_local plugin
* Reduce the amount of metrics coming from haproxy in the default case
* Remove pylint from the dependencies
* Add infomation for Kafka Checks
* Updated the document for Apache Web Server Checks
* Allow a comma separated list of hosts for host\_alive detection plugin
* Filtering bad metrics in the aggregator
* Added process openvswitch-ovsdb for monitoring and modified the process name from service name. Modified the group name
* Mitigates job\_status dict change during iteration
* Ensure libvirt's hostnames are used by collector
* Added the ability to remove configuration and did various cleanup
* psutil 3.1+ is broken
* This detection plugin will monitor OVSvApp daemons as part of OVSvApp service VM functionality for ESX compute host.Removed the logging process
* Added dry run mode to monasca-setup
* Skip processes that have disappeared since the loop begun
* Add heat service detection plugin
* + elasticsearch.thread\_pool.<pool>.rejected metrics
* VM up/down status metrics, other libvirt changes

1.1.10
------

* Log and ignore vms not known to nova
* Ensure password field is valid yaml
* add support for (user-) domain\_id/name
* Compare flavors as lower case
* args should be optional
* Corrected process name in keystone plugin
* Add documentation for the crash check plugin
* Added an haproxy detection plugin

1.1.9
-----

* Add a detection plugin for the crash check plugin
* Cleanup the rabbitmq detection plugin and add parsing of arguments
* Be more explicit about which keystone processes to watch
* Documentation and all service\_plugins get disable\_http\_check functionality
* Remove value-meta checking when queuing metrics
* Change metric\_type to a metric class for the aggregator
* Making sure ntp does not point to localhost
* Added back in the libvirt metrics to the docs
* Check for local crash dumps
* Add correct checks\_d path before attempting to load modules
* Lower default collection time from 60 seconds to 30
* Update search pattern for Keystone setup plugin
* Allow hostname set by a plugin in dimensions to be used in a metric
* Create dropwizard plugin for collecting metrics via http
* Change service plugin to choose an alternate ip if needed
* Exclude a number of network devices from the default config
* Allow additional customization of HttpCheck
* Add cinder-backup to the list of services monitored
* Fix the ntp and postfix detection bugs
* Clean up metric pipline

1.1.8
-----

* Add l3-agent to process checks in neutron plugin
* Reduced kafka metrics in the default case

1.1.7
-----

* Add the args parameter
* Add wait time to refresh tokens

1.1.6
-----

* Refactors swift metrics into separate check
* Misc doc fixes
* Fix network excluded interfaces check
* Added disable\_http\_check option to the nova detection plugin
* Save last\_check\_data before return on nagios check
* Only setup the http check for machines with neutron-server
* mysql plugin fix
* Change the default log level to WARN
* Removed swift diag commands that aren't in the standard swift deploy
* Fix libvirt id lookup

1.1.5
-----

* Add dimensions support to the argument based detection plugins

1.1.4
-----

* Detect the port of the api before setting up an http check
* Better handling of an invalid zookeeper path in the kafka plugin
* Warn when detection fails for a specificly called out plugin
* Cleaned up detection of Monasca components

1.1.3
-----

* Fixed detection plugins that aren't using the parent init

1.1.2
-----

* Added host alive and http\_check plugins and detection\_args
* Allow custom keystone configuration
* Fix histogram list construction
* Added name to the detection plugin example

1.1.1
-----

* Add Agent plugins for Check\_MK and MK\_Livestatus
* Change the default agent user to mon-agent
* Make sure the gid is detected after it is created

1.1.0
-----

* Modify the agent and setup to accept custom plugins
* Always restart monasca agent even on clean exit
* Updated merge that avoid duplicating named instances in a config
* Improve logging for process check
* Fixes from Craig I missed in the first round
* Docs to describe customizations. Added readthedocs config

2015.1
------

* Added the ability to just detect/setup a subset of plugins

1.0.30
------

* Added a systemd service provider

1.0.29
------

* Changes to enable an install via a virtual env
* Suppress nagios\_wrapper valueMeta for empty detail
* Add aggregate metrics to libvirt
* Re-sync Agent Collector's virt dir with Ceilometer

1.0.28
------

* Fix in-place operation on reset values
* Exception wrapper to handle type errors
* Adds region option to libvirt plugin config
* Seggregates diagnostics in swift detection plugin
* Improve logging for nagios\_wrapper failures
* Fix the documentation for emit\_time\_sec

1.0.27
------

* Fixes monasca collector erroring out
* Added additional core related cpu and aggregated disk metrics
* Adding value\_meta to certain metrics
* Default the agent to a 1 minute collection time
* Add metric\_name field to nagios\_wrapper
* Incorrect platform check fix

1.0.26
------

* Update default filesystems ignored by disk check
* Add the --system\_only option to monasca-setup
* Devstack compatibility updates for libvirt

1.0.25
------

* Fixing issue with disk metrics

1.0.24
------

* Fixes keystone endpoint check token failure
* Added a sleep between stop/start to allow stop to fully complete
* Set the dimension element to an empty dict initially

1.0.23
------

* Changes to restore python 2.6 support
* Fixed host\_alive doc to note the name requirement
* Use a system configured ntp server if found for ntp checks
* Conversion to milliseconds

1.0.22
------

* Added more specific error messages when messages need to be queued for tha API
* Converted the agent config file to yaml to match the plugin config files
* Removing subprocess call from system metrics classes
* Added a config file for documentation generation using Markdown and readthedocs.org

1.0.21
------

* Removed the monasca\_statsd\_agregator\_interval.  This was related to the normalize functionality that was removed in the past and was causing errors in the Histogram and Counter calculations in statsd metrics
* Fixed issue with the flush interval
* Various fixes to make it easier to run in diverse environments
* Update all plugins to handle dimensions correctly
* Added swift and ntp checks and more automatic detection
* Fixing issue with detection of the Keystone openstack process
* Fix kafka\_consumer detection plugin for localhost
* Modifications to accommodate for python 2.6
* Minor cleanup to the detection of openstack changes
* Fixing monasca-agent check and check\_all

1.0.20
------

* Remove emit\_time from the collector and put it into the forwarder
* Fixing rate metrics

1.0.19
------

* Adding apache web server monitoring for OpenStack
* Moved to using psutil for some system metrics
* Changed it so you have to explicitly choose the detailed process metrics
* Rewrote config processing to simplify logic

1.0.18
------

* Bug fixes for http\_check using keystone and rabbitmq

1.0.17
------

* Removed the BucketGauge class as it is not used anymore
* Add configuration for system metrics
* Updated dimension processing for service and component
* Clarify Libvirt documentation
* Remove functionality that sends 0 values when counters don't report
* Various fixes and code cleanup related to monasca statsd

1.0.16
------

* Fixed a couple of issues with the monasca-statsd process startup and logging

1.0.15
------

* Renaming agent packages to reflect monasca
* Fixed perc calculations to be 0->100 rather than < 1
* Fixed issue with agent startup if Keystone is down
* Fix detection of Zookeeper in monasca-setup
* Added annotated example config for libvirt plugin
* Adding check for required dependencies in setup

1.0.14
------

* Correct number of return values from \_load\_conf

1.0.13
------

* Remove IP address from shared storage device name

1.0.12
------

* Agent documentation updates
* Add the ability to amplify metric payloads

1.0.11
------

* Removing dependency on hard-coded version file
* Revert change in libvirt plugin identity API ver
* Fixing restart issue when monasca-setup is re-run
* Remove obsolete config options in libvirt plugin
* Improved error handling in kafka\_consumer
* Fixing issue with dimensions in aggregator

1.0.10
------

* Added --dimensions to monasca-setup
* Updating agent keystone authentication
* Closes-Bug: Calling update in aggregator.py does not return any value. Updated to the correct way of calling it

1.0.9
-----

* Updating metrics names and dimensions to be consistent

1.0.8
-----

* Bump version to 1.0.8
* Fix runaway threads in kafka\_consumer agent plugin

1.0.7
-----

* Add support for VM monitoring
* Fixing issue with API reconnection
* Fixed mon-api false positive
* Fix kafka\_consumer detection plugin
* Use FQDN instead of short hostname in all metrics
* Fix detection and operation of Kafka plugin
* Fixing bug in statsd processing
* Remove 'detail' dimension, fix a couple bugs

1.0.6
-----

* Adding RabbitMQ detection and setup

1.0.5
-----

* Bumping agent version to 1.0.5
* Cleaned up a lot of the Pep8 violations
* Remove hardcoded version
* Updating metric names to match new format
* Increase usefulness of Agent diagnostic commands
* Copy /root/.my.cnf credentials into mysql.yaml
* Additional documentation updates
* Change mode of requirement files
* Updated agent documentation
* Enable hacking check H234
* Enable hacking check H233
* Use service names rather than code names. Add montoring
* Remove unneeded definitions of Python Source Code Encoding
* Updating the documentation

1.0.4
-----

* Fixing psutil version issue. Bump Version
* Let git ignore files in all egg directories
* Add hacking as test requirement and use flake8 instead of pep8

1.0.3
-----

* Added monsetup package to setup.cfg

1.0.2
-----

* Adding setup.cfg file Adding manifest file Removing CHANGELOG.md since pbr generates that

1.0.0
-----

* Rename package to monasca-agent
* Adding gitreview config
* Initial tox setup and misc pep8 fixes
* Updated changelog for 1.0.7
* Reverted version bump
* supervisord missing correct path on boot
* Fix plugin returning no data, some pep8 updates
* Reverted version bump
* Removing code for default alarms from mon-setup
* supervisord missing correct path on boot
* Fix plugin returning no data, some pep8 updates
* Line wrapping changes
* Various pep-8/style/Python 3 compatibility fixes
* Fixed various pep 8 warnings
* Fix E721 -  do not compare types, use 'isinstance()'
* Adjusted whitespace for pep8 compliance
* Added new OpenStack services
* Fixed various pep 8 warnings
* Fix E721 -  do not compare types, use 'isinstance()'
* Adjusted whitespace for pep8 compliance
* Fixed Laconic filter import
* \_\_init\_\_.py fixes for monagent
* Minor name change
* mon setup pep8 fixes
* Fixed \_\_init\_\_ in monsetup
* Moved modification of URL to get\_token method
* Fixed one minor bug in MonAPI class
* Removed the try/except in constructor, moved the client object creation to separate method
* Fixing Keystone URL to be base URL only
* Fixing bug in token handling.  Removing /tokens from keystone URL
* Fixing bug in token handling.  Removing /tokens from keystone URL
* Removed 'Monasca' references
* Version bump and changelog update
* Added multithreading support to "active check" plugins
* Added Swift and Cinder auto-detection and setup
* Fix collector crash from long-running plugins
* Fixes to http\_check for keystone token
* Fixed some minor issues
* Adding Nova detection and auto-setup
* Keystone authentication improvements
* Fixed one missed project\_id reference
* mon-setup release
* Added the project\_name to the readme
* Added project name to the keystone config
* Added deep merge to agent.conf also
* Added deep merge of plugin\_config, only a shallow was happening
* Initial detection and config of monitoring stack
* Fix user/permissions on agent.conf
* Added postfix but disabled when I realized it needs passwordless sudo
* Minor initial setup setup bug fixes
* Initial setup of zookeepr and kafka
* Initial implementation of mysql detection
* Updated changelog and minor yaml.example tweak for 1.0.4
* Added default help formatter
* Misc cleanup of some hardcoded paths
* Permission cleanup
* Structural changes to allow a single detection plugin to setup multiple plugins
* Version bump
* Added per-instance dimension support to "active check" plugins
* Better output
* Added really simple network plugin to mon-setup
* Initial working mon-setup
* Initial sketch of what monsetup could look like
* Initial working mon-setup
* Initial sketch of what monsetup could look like
* Fixed issue where proxy settings were used by the emitter
* Brought changelog up to date for 1.0.3
* Run supervisord as the mon-agent user, not root
* Fixing request format for Keystone token retrieval
* Add egg-info directory to .gitignore
* New quick quick overview of the Monitoring Agent
* JAH-233 http\_check unroutable network exception
* Moving version information to central location
* Fixed pep8 issues, bumped version and removed an unused variable
* Fixed bug in Keystone processing
* Removed aggregate\_metrics and mapping\_file, updated conf.example
* Fixed pep8 issues, bumped version and removed an unused variable
* JAH-211 forwarder bug fix, JAH-222 metric rename
* Fixed bug in Keystone processing
* Bumping version in config file
* Bumping version
* Fixing Keystone class
* Integrating python-monclient into agent
* Version bump to 1.0.1
* JAH-197: Subsequent dimensions missing in certain plugins
* Fixed find\_packages, remove . from package name
* Configured setup.py so it will work for installing
* Fix wiki link
* added HP to license copyright
* Fixes for issues encountered now that we use dimensions
* Update README.md
* Update README.md
* Some test fixes
* Changed monstatsd to use the standard emitter
* Renamed dogstatsd->monstatsd
* Removing the statsd-gen, it should be updated and put with the statsd client code
* Added wiki link
* Fixes for the odd pathing done with a deb install
* Moved disk/inodes to including device as a dimension
* moved checks.d to use Measurements, forwarder and old style checks fixes
* Update README.md
* Fixes for running/building
* Finished tag->dimension changes, now for testing
* Misc inspection fixes
* Some test fixes
* Finished removing all need for the mapping file
* Removed/renamed all standard system metrics to our names
* Send hostname dimension with all measurements
* Incorporated Measurement into the forwarder
* Moved to a standardized output from the collector
* Pulled out a few items discarded in the normalizer
* Partial move of collect to dimensions, and some pep8 cleanup
* Pulled metrics into their own module and out of aggregator
* JAH-127 reorganized components to acheive a clearer seperation
* Pulled tags from the forwarder, needs corresponding changes in the collector
* Fixed issues caused by fault refactoring
* force aggregate message to mon api, moved aggregator.py into a common dir
* Fixed/cleaned up passing of config dimensions to the emitter
* Removed google compute engine host tags
* Fixed and disabled more tests
* Unit test cleanup, mostly disabling tests with external requirements
* Removed custom emitters from the config
* Removed custom emitters
* minor log fix and brief look at emitter functionality
* Minor fix to make what is happening in package install a bit more clear
* Fixes following the initial rebranding
* Initial remove of datadog branding, rpm support and moved mapping file location
* Removed in favor of just using the package version
* Clarified collector and collector\_daemon
* Clarified our custom check names, removed duplicates
* Removed redundant example configs
* Removed nagios check from dd
* Fixed bug introduced with too aggressive inspection fixes
* More pep8 changes
* Bunches of pep8 fixes
* inspection fixes, mostly static methods
* A few more inspection fixes, lots more to come
* Cleaned up lots of imports unnecessarily going to util
* Finished very initial move from custom emitter to a full transactional emitter
* Turned off gzip since the emitter is only used to localhost
* bumped version, removed licenes files for code no longer embeded
* Working deb build
* Changes to get the collector working
* Cleaned up the changelog
* Changes to make the forwarder work
* The first few fixes from code inspection
* Ripped out the datadog remote bits of the forwarder
* removed embeded ntplib
* Removed embeded httplib2
* Removed boto and ec2 related metadata
* Removed embeded collections library
* Removed embedded pyyaml
* collector only sends metrics to the forwarder, pulled out ganglia
* Renamed monagent.mon\_lib.mon\_api and friends to drop extra mons
* Roland's changes from meeting on 4/24
* On closer look moving pup isn't the right decision
* Pulled out unused bits, move pup to standalone
* Removed duplicate tests directory
* renamed collector/fowarder to decent names
* Minor cleanup according to code conventions
* Initial relocation of deb creation scripts. monagent should be a python module
* Removed files from dd not used by mon
* Moved root level stuff to the root
* Switching from tags to dimensions
* Log directory change in package post-install
* Fix for build failure #65, missing log directory
* Fixing data processing issues
* Fixing issue with statsd processing
* Combine and fix permissions on logfile directories
* Removed pbuilder stuff
* Fixing issue with readme
* Adding a statsd generator utility for testing of statsd metrics
* Moving emitter from collector to forwarder
* New little script to test checks.d plugins manually
* Fix in soon-to-be-obsolete pbuilder install path
* Removed all the "jah" and "Jah"
* Rename monapi directory to jahmon\_lib
* First pass rename of mon-agent to jahmon-agent
* First pass switch from mon-agent to jahmon-agent
* Fix FPM dependencies
* FPM: Renaming datadog-agent to mon-agent
* Full merge against Datadog's agent 4.2.0
* Fixing issue with % sign
* Fixing issue with metrics processing
* Fixing issue with metrics processing
* Fixing issue with metrics processing
* Fixing issue with metrics processing
* Fixing issue with metrics processing
* Fixing issue with metrics processing
* Fixing issue with metrics processing
* Fixing issue with metrics processing
* Fixing issue with metrics processing
* Add python-psutil depdendency to support process.py
* Fixing JSON strings
* Fixing JSON strings
* Adding flag for turning off mon-api emitter
* Temporary hack for supervisord failing to ID its procs
* Activate dogstatsd, include some upstream changes
* Adding flag for turning off mon-api emitter
* Adding flag for turning off mon-api emitter
* Adding flag for turning off mon-api emitter
* Adding flag for turning off mon-api emitter
* Added mapping and filtering code
* Minor postinst changes for a cleaner install
* Updated for functional agent .deb (initial push)
* Added install file for pbuilder
* Updating control file
* Adding supervisor
* Cleaning up unneeded files and rename agent.conf to datadog.conf to retain compatability with dd-agent
* Fixing postinst Adding init script
* Fixing postinst Adding init script
* Fixing postinst Adding init script
* Fixing postinst Adding init script
* Fixing postinst Adding init script
* Fixing postinst
* Fixing postinst
* Fixing postinst
* Fixing postinst
* Fixing postinst
* Fixing postinst
* Fixing deb package
* New http\_check, added yaml examples for all checks
* Changing postinst to preinst
* Adding postinstall and postrm files
* Removing some code customizations to use more of DD codebase.  Adding another dependency
* Fixing issue in control file
* Fixing issue in control file
* Fixing issue in control file
* Removing build dependencies
* Reverting to old debian structure
* Reverting to old debian structure
* Addin additional files for deb package
* More fixes to Debian configuration
* More fixes to Debian configuration
* Added file for upstart to work
* Removing non-runtime dependencies
* Fixing package names in debian package
* Fixing package names in setup.py
* Fixing dependency issue, import issue and adding .gitignore file
* Removed pyc files from git.  Fixed some issues in the code
* Refactoring code and getting message format correct
* Fix: 'detail:' string missing on nagios\_wrapper tags
* First commit of agent checks for Nagios & ping
* Refactoring of agent code
* Moved example config files to a config directory
* Removed sommon from changelog
* Syntax issues in the control
* Minor fixed to the deb enviroment
* Rearranging and adding file structure for Debian packaging
* Adding initial code for writing metrics to mon-api
* Initial commit
